/// @file

#if !defined cmif_StringFunctionParser_h
#define cmif_StringFunctionParser_h

#include "DefaultScore.h"

namespace cmif
{
		/// A string function parser. This processes strings only.
	struct StringFunctionParser: 
		public DefaultScore<double>
    {
		typedef std::map<std::string, std::string> StringSymbols; ///< Convenience definition of symbol string map
		typedef std::map<std::string, double> Symbols;	///< Map of symbol values. This hides the spirit symbol table from the client

		static double evaluate(const std::string& s, const Symbols& symbols);
		static std::string evaluate(const std::string& s, const StringSymbols& smap);

			// overridden virtual methods
		void hasDefaultScore(bool b);
		void defaultScore(const double& d);
    };
}

#endif // cmif_StringFunctionParser_h
